const convertToString = x =>
  typeof x === "object" ? JSON.stringify(x) : String(x);

module.exports = (...args) => {
  if (args.length === 0) {
    return "";
  }
  const head = args[0];
  const tail = args.slice(1);
  let i = 0;
  let ret = "";
  if (typeof head === "string") {
    ret = String(head).replace(/%[sfidOoj]/g, x => {
      if (!tail[i]) {
        return String(x);
      }
      switch (x) {
        case "%s":
          return String(tail[i++]);
        case "%f":
          return Number(tail[i++]).toString();
        case "%i":
        case "%d":
          return parseInt(tail[i++], 10).toString();
        case "%O":
        case "%o":
        case "%j":
          return JSON.stringify(tail[i++]);
        default:
          return String(x);
      }
    });
  } else {
    ret = convertToString(head);
  }
  if (i < tail.length) {
    return (
      ret +
      " " +
      tail
        .slice(i)
        .map(x => convertToString(x))
        .join(" ")
    );
  }
  return ret;
};
